Attribute VB_Name = "Module1"
Option Explicit
'REQUIRES: Reference to Microsoft Scripting Runtime
'************************* VARIABLES *********************************
Private FSO As FileSystemObject
Public serverPrefix As String
Public totalFilesCount As Integer
Public topFolder As String
'*********************************************************************

Public Sub PathLogInit()
    Set FSO = New FileSystemObject
    serverPrefix = "http://someserver.com/"
    topFolder = "music"
End Sub

'*** This function parses through the directory tree and generates PLS files
'*** in each directory
Public Sub createPLSfn(dirpath As String)
    Dim myParentFolder As Folder
    Dim subFolders As Folders
    Dim mySubFolder As Folder
    Dim myFiles As Files
    Dim myFile As File
    Dim myFileExtension As String
    Dim parsedPath As String
    Dim trimlettersno As Long
    Dim fileCount As Integer
    Dim fileString As String
    Dim playlistText As String
        
    Set myParentFolder = FSO.GetFolder(dirpath)
       
    Set subFolders = myParentFolder.subFolders
    For Each mySubFolder In subFolders
        Call createPLSfn(mySubFolder.Path)
    Next
    
    '*** Now dealing with only the files in this folder ***
    parsedPath = myParentFolder.Path
    trimlettersno = InStr(parsedPath, topFolder)
    parsedPath = Right(parsedPath, Len(parsedPath) - trimlettersno + 1)
    parsedPath = Replace(parsedPath, "\", "/")
    
    Set myFiles = myParentFolder.Files
    fileCount = 0
    playlistText = ""
    playlistText = "[playlist]" + vbNewLine
    If myFiles.Count > 0 Then
        For Each myFile In myFiles
            myFileExtension = Right(myFile.Name, 3)
            If (myFile.Name <> (myParentFolder.Name + ".pls")) And _
            (StrComp(myFileExtension, "mp3", vbTextCompare) = 0) Then
                fileString = ""
                fileCount = fileCount + 1
                fileString = fileString + "File" + CStr(fileCount) + "=" + _
                            serverPrefix + parsedPath + "/" + myFile.Name
                fileString = Replace(fileString, " ", "%20")
                fileString = Replace(fileString, "(", "%28")
                fileString = Replace(fileString, ")", "%29")
                playlistText = playlistText + fileString + vbNewLine
            End If
        Next
        playlistText = playlistText + "NumberOfEntries=" + CStr(fileCount) + vbNewLine
        Call writePLS(playlistText, myParentFolder.Path, myParentFolder.Name)
    End If
End Sub

Public Sub writePLS(playlist As String, location As String, plsfilename As String)
    Dim myPLS As Scripting.TextStream
    Dim fileLocation As String
    fileLocation = location + "\" + plsfilename + ".pls"
    Set myPLS = FSO.CreateTextFile(fileLocation, True)
    myPLS.Write (playlist)
    Form1.Text1.Text = Form1.Text1.Text + plsfilename + ".pls" + vbNewLine
    totalFilesCount = totalFilesCount + 1
    myPLS.Close
End Sub

'*** This function removes all PLS files inside a directory tree.
Public Sub deletePLSfn(dirpath As String)
    Dim myParentFolder As Folder
    Dim subFolders As Folders
    Dim mySubFolder As Folder
    Dim outputMsg As String
    
    outputMsg = ""
    Set myParentFolder = FSO.GetFolder(dirpath)
    Set subFolders = myParentFolder.subFolders
    For Each mySubFolder In subFolders
        Call deletePLSfn(mySubFolder.Path)
        If (FSO.FileExists(mySubFolder.Path + "\" + mySubFolder.Name + ".pls") = True) Then
            FSO.DeleteFile mySubFolder.Path + "\" + mySubFolder.Name + ".pls", True
            outputMsg = outputMsg + mySubFolder.Name + ".pls" + vbNewLine
            totalFilesCount = totalFilesCount + 1
        End If
    Next
    If (FSO.FileExists(myParentFolder.Path + "\" + myParentFolder.Name + ".pls") = True) Then
        FSO.DeleteFile myParentFolder.Path + "\" + myParentFolder.Name + ".pls", True
        outputMsg = outputMsg + myParentFolder.Name + ".pls" + vbNewLine
        totalFilesCount = totalFilesCount + 1
    End If
    If (outputMsg <> "") Then
        Form1.Text1.Text = Form1.Text1.Text + outputMsg ' + vbNewLine
    End If
End Sub

Public Sub Terminate()
    Set FSO = Nothing
End Sub
